//#include <QMC5883LCompass.h>
//
//QMC5883LCompass compass;
//
//void setup() {
//  Serial.begin(9600);
//  compass.init();
//}
//
//void loop() {
//
//  int x, y, z, a, b;
//  char myArray[3];
//
//  compass.read();
//
//  x = compass.getX();
//  y = compass.getY();
//  z = compass.getZ();
//
//  a = compass.getAzimuth();
//
//  b = compass.getBearing(a);
//
//  compass.getDirection(myArray, a);
//
//
//  Serial.print("X: ");
//  Serial.print(x);
//
//  Serial.print(" Y: ");
//  Serial.print(y);
//
//  Serial.print(" Z: ");
//  Serial.print(z);
//
//  Serial.print(" Azimuth: ");
//  Serial.print(a);
//
//  Serial.print(" Bearing: ");
//  Serial.print(b);
//
//  Serial.print(" Direction: ");
//  Serial.print(myArray[0]);
//  Serial.print(myArray[1]);
//  Serial.print(myArray[2]);
//
//  Serial.println();
//
//  delay(250);
//}

#include <QMC5883L.h>
#include <Wire.h>

QMC5883L compass;

void setup()
{
  Wire.begin();

  compass.init();
  compass.setSamplingRate(50);

  Serial.begin(9600);
  Serial.println("QMC5883L Compass Demo");
  Serial.println("Turn compass in all directions to calibrate....");
}

void loop()
{
  int heading = compass.readHeading();
  if (heading == 0) {
    /* Still calibrating, so measure but don't print */
  } else {
    Serial.println(heading);
  }
  int r;
  int16_t x, y, z, t;
  r = compass.readRaw(&x, &y, &z, &t);
  Serial.print(x); Serial.print("   "); Serial.print(y); Serial.print("   "); Serial.println(z);
  delay(1000);
}
